# Copyright:   (c) Daryl Fox 2013
# Licence:     CC-BY
#              http://creativecommons.org/licenses/by/3.0/
#-------------------------------------------------------------------------------

import pygame
import random

import config
import util

def show_instructions(screen, effects):
    clock = pygame.time.Clock()

    pages = ['assets/instructions/intro.png',
             'assets/instructions/screen_1.png',
             'assets/instructions/screen_3.png',
             'assets/instructions/screen_2.png',
            ]
    images = [pygame.image.load(i) for i in pages]
    page_ix = 0

    running = True
    while running:
        dt = clock.tick(config.MAX_FPS)
        #######################################################################
        ## Empty the event queue
        #######################################################################
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                import sys
                sys.exit()
            elif event.type in (pygame.KEYDOWN, pygame.MOUSEBUTTONDOWN):
                page_ix += 1
                effects['click'].play()
        if page_ix >= len(images):
            running = False
            continue

        screen.blit(images[page_ix], (0, 0))
        fps = clock.get_fps()
        pygame.display.set_caption('Avidus -- %.01f FPS' % fps)
        pygame.display.flip()

    return

